/**************************************************************************

   FILE NAME:        ClientDlg.cpp 

   FILE DESCRIPTION:
    
   Client/Server networking example program
   Client part
   This is an example program for CPU modules with network connection.

   PROJECT NAME:     ClientServer
	PROJECT VERSION:  (Defined in README.TXT)

	Copyright 2004 RTD Embedded Technologies, Inc.  All Rights Reserved.

	Confidential and Proprietary, Not For Public Release

***************************************************************************/
#include "stdafx.h"
#include "Client.h"
#include "ClientDlg.h"
#include "ClientSocket.h"
#include <Afxsock.h>
#include <afxcmn.h>
#include <afx.h>
#include <afxwin.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


char ip[20];
char cbuf[255],szBuf[255];
BOOL connected = FALSE;

CString strTemp;

// Socket objects
ClientSocket sock_CBase;   // client base socket

// ****************************************************************************
// CClientDlg dialog
// ****************************************************************************

CClientDlg::CClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClientDlg)
	m_textC = _T("");
	m_edit_port = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
		m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClientDlg)
	DDX_Control(pDX, IDC_LISTBOX, m_CMainWindowList);
	DDX_Control(pDX, IDC_IPADDRESS, m_ipaddressfield);
	DDX_Text(pDX, IDC_EDIT1, m_textC);
	DDV_MaxChars(pDX, m_textC, 255);
	DDX_Text(pDX, IDC_EDIT_PORT, m_edit_port);
	DDV_MinMaxUInt(pDX, m_edit_port, 0, 65535);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CClientDlg, CDialog)
	//{{AFX_MSG_MAP(CClientDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDSEND, OnSend)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDINFO, OnInfo)
	ON_BN_CLICKED(IDCLEAR, OnClear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClientDlg message handlers

BOOL CClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
   PORT = 12345;
   SetDlgItemText(IDC_EDIT_PORT,"12345");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


// ****************************************************************************
// CClientDlg::OnConnect() 
//
// Connect to the Server at the given IP address
// ****************************************************************************
void CClientDlg::OnConnect() 
{
	BYTE field1,field2,field3,field4 ;
  
	if (connected)
      {
      MessageBox("Already connected","Message",MB_OK);
      return;
      }

	if (m_ipaddressfield.IsBlank() == TRUE)
      MessageBox("An IP address has not been specified","Error",MB_OK);
	else
		{
      UpdateData(TRUE);
      PORT = m_edit_port;

		if(sock_CBase.m_hSocket)
			sock_CBase.Close();
		m_ipaddressfield.GetAddress(field1,field2,field3,field4);
		sprintf(ip,"%d.%d.%d.%d",field1,field2,field3,field4);

      // initialize Windows sockets
      if(AfxSocketInit(NULL)==0)       
		   MessageBox("Socket Init Failed","Error",MB_OK);

      // Create STREAM type Windows socket and attach it
      if(sock_CBase.Create()==0)   
         {
         sprintf(szBuf,"Socket Create Failed %d",GetLastError());
		   MessageBox(szBuf,"Error",MB_OK);
         }
     
      // Connect at IP address
      AfxGetApp()->DoWaitCursor(1);
		if(!sock_CBase.Connect(ip, PORT))
		   MessageBox("Connect failure","Error",MB_OK);
      else
         {
     	   SetTimer(TM_MEASURE,500,NULL);
   		connected = TRUE;
         sprintf(szBuf,"Connected to %s",ip);
         SetDlgItemText(IDC_IPCON,szBuf);
         }
      AfxGetApp()->DoWaitCursor(-1);

      ::EnableWindow(::GetDlgItem(m_hWnd,IDSEND),TRUE);    // enable send button
      ::EnableWindow(::GetDlgItem(m_hWnd,IDCLEAR),TRUE);   // enable clear button
      }
}


// ****************************************************************************
// CClientDlg::OnSend()
//
// Response on the Send button
// Send text from the message window to the Server
// ****************************************************************************
void CClientDlg::OnSend() 
{
	char strsendname[50];

	if (!connected)
	   MessageBox("You are not connected","Error",MB_OK);
	else
		{
		CWnd* pWnd = GetDlgItem(IDC_EDIT1);
		pWnd->GetWindowText(m_textC);
      sprintf(cbuf,m_textC);

		if(!sock_CBase.Send(cbuf, 255))
		   MessageBox("Error","Send failure",MB_OK);
      else
         {
		   sprintf(strsendname,"Local message: ");
		   strTemp.Format("%s %s",strsendname,cbuf);

		   m_CMainWindowList.AddString(strTemp);
         }
	   pWnd->SetWindowText(_T(""));
		}
}


// ****************************************************************************
// CClientDlg::OnTimer
//
// Check if new packet is available and display it
// ****************************************************************************
void CClientDlg::OnTimer(UINT nIDEvent) 
{
	if(sock_CBase.packet.newdata)
		{
      if(m_CMainWindowList.GetCount()>9)
   	   SendDlgItemMessage(IDC_LISTBOX,LB_RESETCONTENT,0,0);

      // packet string
      sock_CBase.packet.newdata = FALSE;
      strTemp.Format("%s",sock_CBase.packet.scanline);
      m_CMainWindowList.AddString(strTemp);

      // packet counter
      sprintf(szBuf,"%d",sock_CBase.packet.counter);
      SetDlgItemText(IDC_PACKET_COUNT,szBuf);
      }

   CDialog::OnTimer(nIDEvent);
}


// ****************************************************************************
// CClientDlg::OnInfo()
// 
// Response on the Help button
// ****************************************************************************
void CClientDlg::OnInfo() 
{
MessageBox("Connect: connect to a socket at the submitted IP address\n"
           "Send: send text from send window to the server.\n"
           "Clear: erase the Received/Sent window.\n",
           "Help",MB_OK|MB_ICONINFORMATION);
}


// ****************************************************************************
// CClientDlg::OnClear()
// 
// Response on the Clear button
// Clear the Received/Sent window
// ****************************************************************************
void CClientDlg::OnClear() 
{
	SendDlgItemMessage(IDC_LISTBOX,LB_RESETCONTENT,0,0);
}
