/**************************************************************************

   FILE NAME:        ServerDlg.cpp 

   FILE DESCRIPTION:
    
   Client/Server networking example program
   Server part
   This is an example program for CPU modules with network connection.

   PROJECT NAME:     ClientServer
	PROJECT VERSION:  (Defined in README.TXT)

	Copyright 2004 RTD Embedded Technologies, Inc.  All Rights Reserved.

	Confidential and Proprietary, Not For Public Release

***************************************************************************/
#include "stdafx.h"
#include "ServerSocket.h"
#include "Server.h"
#include "ServerDlg.h"
#include <Afxsock.h>
#include <afxcmn.h>
#include <afx.h>
#include <afxwin.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HWND	mainwindow;

char sbuf[255];

CString strTemp1;

// Socket objects
ServerSocket sock_SBase;            // server base socket
ServerSocket *sock_Conn = NULL;     // connected socket (client)

// ****************************************************************************
// CServerDlg dialog
// ****************************************************************************
CServerDlg::CServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CServerDlg)
	m_textS = _T("");
	m_edit_port = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CServerDlg)
	DDX_Control(pDX, IDC_LIST, m_SMainWindowList);
	DDX_Text(pDX, IDC_EDIT1, m_textS);
	DDV_MaxChars(pDX, m_textS, 255);
	DDX_Text(pDX, IDC_EDIT_PORT, m_edit_port);
	DDV_MinMaxUInt(pDX, m_edit_port, 0, 65535);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CServerDlg, CDialog)
	//{{AFX_MSG_MAP(CServerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDLISTEN, OnListen)
	ON_BN_CLICKED(IDSEND, OnSend)
	ON_BN_CLICKED(IDCLEAR, OnClear)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDINFO, OnInfo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CServerDlg message handlers
BOOL CServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	mainwindow = m_hWnd;
	// TODO: Add extra initialization here
	
	packet.counter = 0;
	packet.newdata = FALSE;
   m_socket_created = FALSE;
   PORT = 12345;                 // initialize socket port

   SetDlgItemText(IDC_EDIT_PORT,"12345");
	return TRUE;  // return TRUE  unless you set the focus to a control
}


// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);\
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CServerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


// ****************************************************************************
// CServerDlg::OnTimer()
//
// Create a new packet and send it to the client
// ****************************************************************************
void CServerDlg::OnTimer(UINT nIDEvent) 
{
   if(sock_Conn)  // check if client is connected
      {
      if(m_SMainWindowList.GetCount()>9)
   	      SendDlgItemMessage(IDC_LISTBOX,LB_RESETCONTENT,0,0);

      // write string
	   sprintf(packet.scanline,"Test string %d",packet.counter);
      // increment packet count
      packet.counter++;

      // send to client
      sock_Conn->Send(&packet, sizeof(packet));

      // display in local window
      m_SMainWindowList.AddString(packet.scanline);

      sprintf(sbuf,"%d",packet.counter);
      SetDlgItemText(IDC_PACKET_COUNT,sbuf);
      }
	CDialog::OnTimer(nIDEvent);
}


// ****************************************************************************
// CServerDlg::OnListen()
//
// Response on Create Socket button
// Create a socket and setup a timer for periodic packet sending
// ****************************************************************************
void CServerDlg::OnListen() 
{
   if(!m_socket_created)
      {
      UpdateData(TRUE);
      PORT = m_edit_port;

      // initialize Windows sockets
      if(AfxSocketInit(NULL)==0)       
		   MessageBox("Socket Init Failed","Error",MB_OK);
      
      // Create STREAM type Windows socket and attach it
      if(sock_SBase.Create(PORT)==0)   
		   MessageBox("Socket Create Failed","Error",MB_OK);

      // Start listen for incoming connection requests
	   if(sock_SBase.Listen()==0)
		   MessageBox("Socket Listen Failed","Error",MB_OK);
      
      m_socket_created = TRUE;
  	   SetTimer(TM_SEND,5000,NULL);

      sprintf(sbuf,"Port %d created.",PORT);
      SetDlgItemText(IDC_PORT,sbuf);

      ::EnableWindow(::GetDlgItem(m_hWnd,IDSEND),TRUE);    // enable send button
      ::EnableWindow(::GetDlgItem(m_hWnd,IDCLEAR),TRUE);   // enable clear button
      }
   else
      MessageBox("Socket Already Created","Message",MB_OK);
}


// ****************************************************************************
// CServerDlg::OnClear()
//
// Response on Clear button
// Reset the content of the local Received/Sent window
// ****************************************************************************
void CServerDlg::OnClear() 
{
	SendDlgItemMessage(IDC_LISTBOX,LB_RESETCONTENT,0,0);
}


// ****************************************************************************
// CServerDlg::OnSend()
//
// Response on Send button
// Get text from IDC_EDIT1 edit box and send it to the client
// The text will be displayed also in the local window
// ****************************************************************************
void CServerDlg::OnSend() 
{
 CWnd* pWnd = GetDlgItem(IDC_EDIT1);

 pWnd->GetWindowText(m_textS);
 sprintf(sbuf,m_textS);

 sprintf(packet.scanline,"Remote message: %s",m_textS);
 ++packet.counter;
 
 sock_Conn->Send(&packet, sizeof(packet));

 strTemp1.Format("%s %s","Local message: ",sbuf);

 m_SMainWindowList.AddString(strTemp1);

 pWnd->SetWindowText(_T(""));
}


// ****************************************************************************
// CServerDlg::OnInfo()
// 
// This function displays some help
// ****************************************************************************
void CServerDlg::OnInfo() 
{
MessageBox("Create Socket: installs a socket on your PC.\n"
           "Send: send text from send window to the client.\n"
           "Clear: erase the Received/Sent window.\n",
           "Help",MB_OK|MB_ICONINFORMATION);
}


// ****************************************************************************
// CServerDlg::DestroyWindow()
// 
// Delete connected socket on exit
// ****************************************************************************
BOOL CServerDlg::DestroyWindow() 
{
   if(sock_Conn)           // delete connected client socket
      {      
      sock_Conn->Close();  // close the socket
      delete sock_Conn;
      }
   KillTimer(TM_SEND);
	return CDialog::DestroyWindow();
}


// ****************************************************************************
// ServerSocket::OnAccept
//
// Accept the connection of client to the base socket
// ****************************************************************************
void ServerSocket::OnAccept(int nErrorCode)
{
   CString ip;
   UINT cport;

   if(sock_Conn)
		   MessageBox(0,"Connection refused","Message",MB_OK);
   else
      {
      sock_Conn = new ServerSocket;

	   if (!Accept(*sock_Conn))
		   delete sock_Conn;

      sock_Conn->GetPeerName(ip,cport);   // get client IP address

      sprintf(sbuf,"Client %s connected",ip);
      ::SetDlgItemText(mainwindow,IDC_CONNECTED,sbuf);
      }
}


// ****************************************************************************
// ServerSocket::OnReceive
//
// Receive data from the client
// ****************************************************************************
void ServerSocket::OnReceive(int nErrorCode)
{
	HWND hdlg;
	int error = 0;
	int received = sock_Conn->Receive(sbuf, 255);

	strTemp1.Format("%s %s","Remote message: ",sbuf);
   
   hdlg = GetDlgItem(mainwindow,IDC_LISTBOX);
	
	LPTSTR lpsz = new TCHAR[strTemp1.GetLength()+1];
   
	SendMessage(hdlg,LB_ADDSTRING,0,(LPARAM)_tcscpy(lpsz, strTemp1));
}


// ****************************************************************************
// ServerSocket::OnClose
//
// This function is called if client disconnects
// ****************************************************************************
void ServerSocket::OnClose(int nErrorCode)
{
   ::SetDlgItemText(mainwindow,IDC_CONNECTED,"Client disconnected");
   if(sock_Conn)            // delete connected client socket
      {      
      sock_Conn->Close();  // close the socket
      delete sock_Conn;
      sock_Conn = NULL;
      }
}
